//    TDA7318,  , 6-2007
//ATmega16;   8 ; "rh20071206.c"
#include <avr/io.h> // -
#include <util/delay.h> // 
#include "ks0108.h" //   GLCD
#include "glcd.h" //   GLCD
extern void i2start (void); //  " I2C"
extern void i2write (unsigned char); //"  I2C"
extern unsigned char i2ack (void); //" I2C"
extern void i2stop (void); //  " I2C"
#define VREF 5000L //Vref -   []
//--------------------------------------------------------
int main (void) // 
{	unsigned long volt, ampl; // 
  unsigned char a, b, h; // 
		unsigned int adc; //  
		unsigned char osc[240]; //  
		
  PORTA=0xFC; //PA0, PA1   
		PORTB=PORTC=0xFF; // "", "" -   
  PORTD=0xFD; DDRD=0x02; //PD1 -   .0
  glcdInit(); // GLCD
 	glcdClearScreen(); // 
		glcdRectangle(3, 3, 34, 122); //
		glcdSetAddress(8,LINE6); // 
 	glcdPutStr(" = 0,000 "); // 
		glcdSetAddress(8,LINE7); // 
 	glcdPutStr("V_.   = 2,500 "); // 
//    TDA7318   I2C		
		i2start(); i2write(0x88); // I2C
  if (i2ack() != 0) while (1); // TDA7318 (I2C)
  i2write(0x00); i2ack(); //, 0 
  i2write(0x80); i2ack(); // LF, 0 
  i2write(0xA0); i2ack(); // RF, 0 
  i2write(0xC0); i2ack(); // LR, 0 
  i2write(0xE0); i2ack(); // RR, 0 
  i2write(0x6F); i2ack(); // ,  0 
		i2write(0x7F); i2ack(); // ,  0 
		i2write(0x40); i2ack(); //., +18,5 , -1
  i2stop(); //    I2C
//   ATmega16 		
		// ADMUX:  10 , Vref=AVCC, -0 (PA0)
  ADMUX &= 0xDF & 0x7F & 0xE0; ADMUX |= 0x40;
  // ADCSRA: . ,  ., F=500 
  ADCSRA &= 0xFC & 0xDF; ADCSRA |= 0x80 | 0x40 | 0x04;
		while(1) //  
  { for (ampl=volt=0L, a=0; a<240; a++) // 
		  { ADCSRA |= 0x40; //   
		    while (ADCSRA & 0x40); //  
				  adc = ADCL; //  8  
      adc += ((int)(ADCH & 0x03) << 8); //  
						if(adc > 0x1FF)	ampl += adc - 0x1FF; // ""
						else ampl += 0x1FF - adc; // ""
						volt += adc; // 
						osc[a] = adc/32; // 0...31  
				}
				for (a=h=0; a<120; a++) // 
    { if((osc[a]<16)&&(osc[a+1]>=16)) // "-"/"+"
				  { h=a; break; //   
						} //  
			 } //   
//  
				for (a=h; a<(h+120); a++) glcdSetDot((4+a-h),(35-osc[a]));
    if (++b%4 == 0) //  4       
    { ampl=VREF * ampl / 245760L; //  
      glcdSetAddress(80,LINE6); //   ""
				  glcdWriteChar(ampl/1000L + 0x30); //  
      glcdWriteChar(','); // 
      glcdWriteChar((ampl/100L)%10 + 0x30); // 
      glcdWriteChar((ampl/10L)%10 + 0x30); // 
      glcdWriteChar(ampl%10L + 0x30); // 
				  volt=VREF * volt / 245760L; // 
				  glcdSetAddress(80,LINE7); //   "V_."
				  glcdWriteChar(volt/1000L + 0x30); //  
      glcdWriteChar(','); // 
      glcdWriteChar((volt/100L)%10 + 0x30); // 
      glcdWriteChar((volt/10L)%10 + 0x30); // 
      glcdWriteChar(volt%10L + 0x30); // 
				}
    for (a=12; a>0; a--) _delay_ms(10); //  
//   SB1,   SB2
				if(bit_is_clear(PIND,PD5)) while(bit_is_set(PIND,PD6));
//     
				for(a=0; a<120; a++) glcdClearDot((4+a),(35-osc[a+h]));				
  } //    
} //WinAVR-20070525,   4284  (26,1%)
